/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Access'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Access'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.RobotPermission = factory(root.HarborApi.ApiClient, root.HarborApi.Access);
  }
}(this, function(ApiClient, Access) {
  'use strict';

  /**
   * The RobotPermission model module.
   * @module model/RobotPermission
   * @version 2.0
   */

  /**
   * Constructs a new <code>RobotPermission</code>.
   * @alias module:model/RobotPermission
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>RobotPermission</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RobotPermission} obj Optional instance to populate.
   * @return {module:model/RobotPermission} The populated <code>RobotPermission</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('kind'))
        obj.kind = ApiClient.convertToType(data['kind'], 'String');
      if (data.hasOwnProperty('namespace'))
        obj.namespace = ApiClient.convertToType(data['namespace'], 'String');
      if (data.hasOwnProperty('access'))
        obj.access = ApiClient.convertToType(data['access'], [Access]);
    }
    return obj;
  }

  /**
   * The kind of the permission
   * @member {String} kind
   */
  exports.prototype.kind = undefined;

  /**
   * The namespace of the permission
   * @member {String} namespace
   */
  exports.prototype.namespace = undefined;

  /**
   * @member {Array.<module:model/Access>} access
   */
  exports.prototype.access = undefined;


  return exports;

}));
